// @flow
import type { User } from '../types/User'
export const save = (db: any) => async (user: User) => {
  const { id } = user
  try {
    const userCol = db.collection('users')

    const { value }: { value: User } = await userCol.findOneAndUpdate(
      { id },
      { $set: { user } },
      { returnOriginal: false, upsert: true }
    )

    return value
  } catch (e) {
    throw e
  }
}

export const get = (db: any) => async (id: string) => {
  try {
    const userCol = db.collection('users')

    const user: User = await userCol.findOne({ id })
    if (!user) {
      throw new Error('User Not Found')
    }
    return user
  } catch (e) {
    throw e
  }
}

export const list = (db: any) => async () => {
  try {
    const userCol = db.collection('users')

    const users: Array<User> = await userCol.find().toArray()

    return users
  } catch (e) {
    throw e
  }
}
