// @flow
import type { Offer, SupportedStores } from './Item'

export type UserItemOffer = Offer & {
  url: string,
  itemId: string,
  store: SupportedStores,
  updatedAt: Date
}

export type Goal = {
  price: number,
  result: boolean
}

export type UserItemInput = {
  userId: string,
  groupId: string,
  goal: number
}

export type UserItemDoc = {
  _id: string,
  userId: string,
  groupId: string,
  goal: number,
  result: boolean,
  createdAt: Date,
  updatedAt: Date
}

export type UserItem = {
  userId: string,
  title: string,
  msrp: ?number,
  groupId: string,
  goal: Goal,
  updatedAt: Date,
  offer: UserItemOffer,
  offers: Array<UserItemOffer>
}

export type UserItemQuery = {
  groupId: string,
  userId: string,
  store: SupportedStores
}
